import es, css_arpg, gamethread, weaponlib
from css_arpg import css_arpg

def load():
    css_arpg.skills['Armory'] = {
    'information':
    'This skill regenerates ammo\n\
    Gives you 1 bullet/level\n\
    every 3 seconds in the clip of your held\n\
    weapon, if not full. Otherwise, gives you\n\
    ammo until you\'re at max ammo.\n\
    Clip Regen may not increase the maximum\n\
    clip size of any weapon\n\
Maximum Level: 20',
    'maximum level':20,
    'Level 1':{
                'cost':1,
                'effectiveness':1  
                },
    'Level 2':{
                'cost':2,
                'effectiveness':2 
                },
    'Level 3':{
                'cost':3,
                'effectiveness':3  
                },
    'Level 4':{
                'cost':4,
                'effectiveness':4  
                },
    'Level 5':{
                'cost':5,
                'effectiveness':5  
                },
    'Level 6':{
                'cost':6,
                'effectiveness':6  
                },
    'Level 7':{
                'cost':7,
                'effectiveness':7  
                },
    'Level 8':{
                'cost':8,
                'effectiveness':8
                },
    'Level 9':{
                'cost':9,
                'effectiveness':9
                },
    'Level 10':{
                'cost':10,
                'effectiveness':10
                },
    'Level 11':{
                'cost':11,
                'effectiveness':11
                },
    'Level 12':{
                'cost':12,
                'effectiveness':12
                },
    'Level 13':{
                'cost':13,
                'effectiveness':13
                },
    'Level 14':{
                'cost':14,
                'effectiveness':14
                },
    'Level 15':{
                'cost':15,
                'effectiveness':15
                },
    'Level 16':{
                'cost':16,
                'effectiveness':16
                },
    'Level 17':{
                'cost':17,
                'effectiveness':17
                },
    'Level 18':{
                'cost':18,
                'effectiveness':18
                },
    'Level 19':{
                'cost':19,
                'effectiveness':19
                },
    'Level 20':{
                'cost':20,
                'effectiveness':20
                }
            }
    gamethread.delayedname(3, 'clipRegen', clipRegen)
            
def round_start(ev):
    gamethread.cancelDelayed('clipRegen')
    gamethread.delayedname(3, 'clipRegen', clipRegen)    
    
def round_end(ev):
    gamethread.cancelDelayed('clipRegen')
    
def unload():
    gamethread.cancelDelayed('clipRegen')
    
def clipRegen():
    for userid in es.getUseridList():
        if int(css_arpg.Player(userid).effect('Armory')) and not int(es.getplayerprop(userid, 'CBasePlayer.pl.deadflag')):
            handle = es.getplayerhandle(userid)
            for weapon in weaponlib.getWeaponList('#primary'):
                for index in weapon.indexlist:
                    if es.getindexprop(index, 'CBaseEntity.m_hOwnerEntity') == handle:
                        prop = 0
                        if 'm259' in weapon.get('name').lower():
                            prop = 'CWeaponM249.baseclass.baseclass.baseclass.m_iState'
                        if 'mp5' in weapon.get('name').lower():
                            prop = 'CWeaponMP5Navy.baseclass.baseclass.baseclass.m_iState'
                        if 'g3sg1' in weapon.get('name').lower():
                            prop = 'CWeaponG3SG1.baseclass.baseclass.baseclass.m_iState'
                        if 'm4a1' in weapon.get('name').lower():
                            prop = 'CWeaponM4A1.baseclass.baseclass.baseclass.m_iState'
                        if 'xm' in weapon.get('name').lower():
                            prop = 'CWeaponXM1014.baseclass.baseclass.m_iState'
                        if 'galil' in weapon.get('name').lower():
                            prop = 'CWeaponGalil.baseclass.baseclass.baseclass.m_iState'
                        if 'ak47' in weapon.get('name').lower():
                            prop = 'CAK47.baseclass.baseclass.baseclass.m_iState'
                        if 'p90' in weapon.get('name').lower():
                            prop = 'CWeaponP90.baseclass.baseclass.baseclass.m_iState'    
                        if 'sg550' in weapon.get('name').lower():
                            prop = 'CWeaponSG550.baseclass.baseclass.baseclass.m_iState'    
                        if 'sg552' in weapon.get('name').lower():
                            prop = 'CWeaponSG552.baseclass.baseclass.baseclass.m_iState'    
                        if 'aug' in weapon.get('name').lower():
                            prop = 'CWeaponAug.baseclass.baseclass.baseclass.m_iState'
                        if 'scout' in weapon.get('name').lower():
                            prop = 'CWeaponScout.baseclass.baseclass.baseclass.m_iState'
                        if 'm3' in weapon.get('name').lower():
                            prop = 'CWeaponM3.baseclass.baseclass.m_iState'
                        if 'awp' in weapon.get('name').lower():
                            prop = 'CWeaponAWP.baseclass.baseclass.baseclass.m_iState'
                        if 'mac10' in weapon.get('name').lower():
                            prop = 'CWeaponMAC10.baseclass.baseclass.baseclass.m_iState'
                        if 'famas' in weapon.get('name').lower():
                            prop = 'CWeaponFamas.baseclass.baseclass.baseclass.m_iState'
                        if 'tmp' in weapon.get('name').lower():
                            prop = 'CWeaponTMP.baseclass.baseclass.baseclass.m_iState'
                        if 'ump' in weapon.get('name').lower():
                            prop = 'CWeaponUMP45.baseclass.baseclass.baseclass.m_iState'
                        if not prop:
                            return 0
                        if index:
                            if int(es.getindexprop(index, prop)) == 2:
                                amount_to_give = int(css_arpg.Player(userid).effect('Armory'))
                                amount_to_give2 = 0
                                while amount_to_give:
                                    if es.getindexprop(index, 'CBaseCombatWeapon.LocalWeaponData.m_iClip1') < int(weapon.clip):
                                        es.setindexprop(index, "CBaseCombatWeapon.LocalWeaponData.m_iClip1", es.getindexprop(index, 'CBaseCombatWeapon.LocalWeaponData.m_iClip1') + 1)
                                        amount_to_give -= 1
                                    else:
                                        amount_to_give2 = amount_to_give
                                        amount_to_give = 0
                                while amount_to_give2:
                                    if es.getplayerprop(userid, weapon.prop) < weapon.maxammo:
                                        es.setplayerprop(userid, weapon.prop, es.getplayerprop(userid, weapon.prop) + 1)
                                        amount_to_give2 -= 1
                                    else:
                                        amount_to_give2 = 0
            for weapon in weaponlib.getWeaponList('#secondary'):            
                for index in weapon.indexlist:
                    if es.getindexprop(index, 'CBaseEntity.m_hOwnerEntity') == handle:
                        prop = 0
                        if 'glock' in weapon.get('name').lower():
                            prop = 'CWeaponGlock.baseclass.baseclass.m_iState'
                        if 'elite' in weapon.get('name').lower():
                            prop = 'CWeaponElite.baseclass.baseclass.m_iState'    
                        if 'deagle' in weapon.get('name').lower():
                            prop = 'CDEagle.baseclass.baseclass.m_iState'
                        if 'usp' in weapon.get('name').lower():
                            prop = 'CWeaponUSP.baseclass.baseclass.m_iState'
                        if 'fiveseven' in weapon.get('name').lower():
                            prop = 'CWeaponFiveSeven.baseclass.baseclass.m_iState'
                        if '228' in weapon.get('name').lower():
                            prop = 'CWeaponP228.baseclass.baseclass.m_iState'
                        if not prop:
                            return 0
                        if index:
                            if int(es.getindexprop(index, prop)) == 2:
                                amount_to_give = int(css_arpg.Player(userid).effect('Armory'))
                                while amount_to_give:
                                    while es.getindexprop(index, 'CBaseCombatWeapon.LocalWeaponData.m_iClip1') < int(weapon.clip):
                                        es.setindexprop(index, "CBaseCombatWeapon.LocalWeaponData.m_iClip1", es.getindexprop(index, 'CBaseCombatWeapon.LocalWeaponData.m_iClip1') + 1)
                                        amount_to_give -= 1
                                    while es.getplayerprop(userid, weapon.prop) < weapon.maxammo:
                                        es.setplayerprop(userid, weapon.prop, es.getplayerprop(userid, weapon.prop) + 1)
                                        amount_to_give -= 1
                                        if es.getplayerprop(userid, weapon.prop) == weapon.maxammo:
                                            amount_to_give = 0
    gamethread.delayed(3, clipRegen)